// ChaoLoveIceMDBoy's Empiralist Mod Main Lua Script for SRB2 2.2.10 (2022)

freeslot("TOL_EMPIRALIST")

G_AddGametype({name = "Empiralist", identifier = "empiralist", typeoflevel = TOL_EMPIRALIST, rules = GTR_FRIENDLY, intermissiontype = int_none, description = "Chill out in a 2.5D world currently. In the future, you will be able to do different activities in different worlds."})

local empiralistMapNum = M_MapNumber("MAPE1")

local worldCellBlocks = {
	{"EMPTWCO", "Test World - Corner", false},
	{"EMPTWGR", "Test World - Grass", true},
	{"EMPTWSP", "Test World - Spawn", true}
}

local worldCells = {
	{
		{{"EMPTWCO", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWCO"},
		{"EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR"},
		{"EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR"},
		{"EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWSP", "EMPTWSP", "EMPTWSP", "EMPTWGR", "EMPTWGR", "EMPTWGR"},
		{"EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWSP", "EMPTWSP", "EMPTWSP", "EMPTWGR", "EMPTWGR", "EMPTWGR"},
		{"EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWSP", "EMPTWSP", "EMPTWSP", "EMPTWGR", "EMPTWGR", "EMPTWGR"},
		{"EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR"},
		{"EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR"},
		{"EMPTWCO", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWCO"}},
		4*FRACUNIT, 5*FRACUNIT, 5
	}
}

local playerSpriteLayers = nil

local isBuildingMode = false

local mapEmpiralistDataProgressMode = 0

local mainFilePrefix = "client/Empiralist/Map_data/EMPM1/MapChunk_"

local mainFileExtension = ".dat"

local function toggleHomeMenu(player)
	if not player or not player.valid return end
	local pl_emp = player.empiralist
	if pl_emp.inHomeMenu
		pl_emp.inHomeMenu = false
		pl_emp.currentMenuPage = 0
		pl_emp.currentMenuOption = 0
	else
		pl_emp.inHomeMenu = true
		pl_emp.currentMenuPage = 1
		pl_emp.currentMenuOption = 1
	end
end

local function setupPlayerEmpiralistData(player)
	if not player or not player.valid return end
	if gametype == GT_EMPIRALIST and gamemap == empiralistMapNum and not splitscreen
		local playerID = #player+1
		if player.empiralist == nil or type(player.empiralist) != "table"
			player.empiralist = {}
		end
		if player.empiralist.worldCell == nil or type(player.empiralist.worldCell) != "number"
			player.empiralist.worldCell = 1
		end
		if player == consoleplayer
			if player.empiralist.inHomeMenu == nil or type(player.empiralist.inHomeMenu) != "boolean"
				player.empiralist.inHomeMenu = false
			end
			if player.empiralist.currentMenuPage == nil or type(player.empiralist.currentMenuPage) != "number"
				player.empiralist.currentMenuPage = 0
			end
			if player.empiralist.currentMenuOption == nil or type(player.empiralist.currentMenuOption) != "number"
				player.empiralist.currentMenuOption = 0
			end
			if player.empiralist.allowMovement == nil or type(player.empiralist.allowMovement) != "boolean"
				player.empiralist.allowMovement = true
			end
		end
		chatprintf(player, "\131NOTICE: \128Please press the score key to toggle movement as there is a bug in SRB2 involving the KeyDown hook!\n")
		if player.empiralist.currentBlock == nil or type(player.empiralist.currentBlock) != "number"
			if isBuildingMode
				player.empiralist.currentBlock = 1
			else
				player.empiralist.currentBlock = 0
			end
		end
		if not player.mo or not player.mo.valid return end
		if player.mo.empiralist == nil or type(player.mo.empiralist) != "table"
			player.mo.empiralist = {}
		end
		if player.mo.empiralist.charSpriteX == nil or type(player.mo.empiralist.charSpriteX) != "number"
			if isBuildingMode
				player.mo.empiralist.charSpriteX = worldCells[player.empiralist.worldCell][2]
			else
				player.mo.empiralist.charSpriteX = worldCells[player.empiralist.worldCell][2]+FixedMul(((playerID-1)%13)*FRACUNIT, FRACUNIT/4)
			end
		end
		if player.mo.empiralist.charSpriteY == nil or type(player.mo.empiralist.charSpriteY) != "number"
			if isBuildingMode
				player.mo.empiralist.charSpriteY = worldCells[player.empiralist.worldCell][3]
			else
				if playerID >= 1 and playerID <= 12
					player.mo.empiralist.charSpriteY = worldCells[player.empiralist.worldCell][3]
				elseif playerID >= 13 and playerID <= 24
					player.mo.empiralist.charSpriteY = worldCells[player.empiralist.worldCell][3]+(FRACUNIT/4)
				elseif playerID >= 25 and playerID <= 32
					player.mo.empiralist.charSpriteY = worldCells[player.empiralist.worldCell][3]+(FRACUNIT/2)
				end
			end
		end
		if player.mo.empiralist.charSpriteAngle == nil or type(player.mo.empiralist.charSpriteAngle) != "number" and not isBuildingMode
			player.mo.empiralist.charSpriteAngle = worldCells[player.empiralist.worldCell][4]
		else
			player.mo.empiralist.charSpriteAngle = nil
		end
	else
		player.empiralist = nil
	end
end

local function resetPlayerEmpiralistData()
	if gametype == GT_EMPIRALIST and gamemap == empiralistMapNum
		for player in players.iterate
			if player and player.valid
				player.empiralist = nil
				if player.mo and player.mo.valid
					player.mo.empiralist = nil
				end
				setupPlayerEmpiralistData(player)
			end
		end
	end
end

COM_AddCommand("emp_toggleBuildingMode", function(player)
	if not player or not player.valid return end
	if splitscreen return end
	if gametype == GT_EMPIRALIST and gamemap == empiralistMapNum
		if isBuildingMode
			isBuildingMode = false
			print("Building mode now has been disabled!\n")
		else
			isBuildingMode = true
			print("Building mode now has been enabled!\n")
		end
		resetPlayerEmpiralistData()
	end
end, COM_ADMIN)

local function readMapEmpiralistDataLine(file, filename, line, mapPosY)
	if not file or not line return end
	worldCells[1][1][mapPosY] = {}
	local mapPosX = 1
	for w in string.gmatch(line, "%w+")
		if w and type(w) == "string" and w != "nil"
			worldCells[1][1][mapPosY][mapPosX] = w
		else
			worldCells[1][1][mapPosY][mapPosX] = nil
		end
		mapPosX = $+1
	end
	local nextLine = file:read("*l")
	return readMapEmpiralistDataLine(file, filename, nextLine, mapPosY+1)
end

COM_AddCommand("emp_loadMapEmpiralistData", function(player)
	if not player or not player.valid return end
	if splitscreen return end
	if gametype == GT_EMPIRALIST and gamemap == empiralistMapNum
		if mapEmpiralistDataProgressMode CONS_Printf(player, "\133ERROR: \128Empiralist map data is currently in process of loading or saving!\n") return end
		mapEmpiralistDataProgressMode = 1
		local mainFileName = mainFilePrefix + "1_1" + mainFileExtension
		// TODO: Rewrite loading system to use chunks so that more than one chunk can be used!
		local mainFileToLoad = io.open(mainFileName, "r", function(file, filename)
			if not file
				print("\133ERROR: \128"+filename+" has failed to load!\n")
				mapEmpiralistDataProgressMode = 0
				if player == consoleplayer
					toggleHomeMenu(player)
				end
				return
			end
			worldCells[1][1] = {}
			local line = file:read("*l")
			if not line
				print("\133ERROR: \128"+filename+" is empty!\n")
				mapEmpiralistDataProgressMode = 0
				if player == consoleplayer
					toggleHomeMenu(player)
				end
				return
			end
			readMapEmpiralistDataLine(file, filename, line, 1)
			print(filename + " has successfully loaded!\n")
			mapEmpiralistDataProgressMode = 0
			resetPlayerEmpiralistData()
		end)
	end
end, COM_ADMIN)

local function saveMapDataEmpiralistLine(file, mapPosY, mapChunkX, mapChunkY)
	if not file or mapPosY > 256 return end
	local realMapPosXStart = (mapChunkX-1)*256+1
	local realMapPosXEnd = realMapPosXStart+255
	local realMapPosY = (mapChunkY-1)*256+mapPosY
	for i = realMapPosXStart,realMapPosXEnd
		if worldCells[1][1][realMapPosY] and type(worldCells[1][1][realMapPosY]) == "table" and worldCells[1][1][realMapPosY][i] and type(worldCells[1][1][realMapPosY][i]) == "string" 
			file:write(worldCells[1][1][realMapPosY][i])
		else
			file:write("nil")
		end
		if i % 256
			file:write(", ")
		end
	end
	if mapPosY != 256
		file:write("\n")
	end
	return saveMapDataEmpiralistLine(file, mapPosY+1, mapChunkX, mapChunkY)
end

COM_AddCommand("emp_broadcastMessage", function(player, message)
	if not player or not player.valid return end
	if not message or type(message) != "string" return end
	if splitscreen return end
	if gametype == GT_EMPIRALIST and gamemap == empiralistMapNum
		print(message)
	end
end, COM_ADMIN)

local function saveMapEmpiralistDataChunkFile(mapChunkX, mapChunkY)
	local mainFileName = mainFilePrefix + tostring(mapChunkY) + "_" + tostring(mapChunkX) + mainFileExtension
	local mainFileToSave = io.openlocal(mainFileName, "w")
	local messagesToPrint = {}
	if mainFileToSave
		saveMapDataEmpiralistLine(mainFileToSave, 1, mapChunkX, mapChunkY)
		mainFileToSave:close()
		messagesToPrint[1] = mainFileName
		messagesToPrint[2] = "has successfully saved!\n"
		/*
		if mapChunkX == 4 and mapChunkY < 4
			return saveMapEmpiralistDataChunkFile(1, mapChunkY+1)
		elseif mapChunkX < 4
			return saveMapEmpiralistDataChunkFile(mapChunkX+1, mapChunkY)
		else
		*/
			COM_BufInsertText(player, "emp_broadcastMessage \"" + table.concat(messagesToPrint, " ") + "\"")
		//end
	else
		messagesToPrint[1] = "\133ERROR: \128"
		messagesToPrint[2] = mainFileName
		messagesToPrint[3] = "has failed to save!\n"
		COM_BufInsertText(player, "emp_broadcastMessage \"" + table.concat(messagesToPrint, " ") + "\"")
	end
end

COM_AddCommand("emp_saveMapEmpiralistData", function(player)
	if not player or not player.valid return end
	if splitscreen return end
	if gametype == GT_EMPIRALIST and gamemap == empiralistMapNum
		if mapEmpiralistDataProgressMode CONS_Printf(player, "\133ERROR: \128Empiralist map data is currently in process of loading or saving!\n") return end
		mapEmpiralistDataProgressMode = 2
		local messagesToPrint = {}
		if isserver
			saveMapEmpiralistDataChunkFile(1, 1)
		end
		mapEmpiralistDataProgressMode = 0
		if isserver
		end
		if player == consoleplayer
			toggleHomeMenu(player)
		end
	end
end, COM_ADMIN)

COM_AddCommand("emp_resetMapEmpiralistData", function(player)
	if not player or not player.valid return end
	if splitscreen return end
	if gametype == GT_EMPIRALIST and gamemap == empiralistMapNum
		worldCells = {
			{
				{{"EMPTWCO", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWCO"},
				{"EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR"},
				{"EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR"},
				{"EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWSP", "EMPTWSP", "EMPTWSP", "EMPTWGR", "EMPTWGR", "EMPTWGR"},
				{"EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWSP", "EMPTWSP", "EMPTWSP", "EMPTWGR", "EMPTWGR", "EMPTWGR"},
				{"EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWSP", "EMPTWSP", "EMPTWSP", "EMPTWGR", "EMPTWGR", "EMPTWGR"},
				{"EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR"},
				{"EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR"},
				{"EMPTWCO", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWGR", "EMPTWCO"}},
				4*FRACUNIT, 5*FRACUNIT, 5
			}
		}
		resetPlayerEmpiralistData()
	end
end, COM_ADMIN)

local homeMenuOptionFuncs = {
	empiralistHomeMenu = {
		toggleBuildingMode = function(player, key)
			if not player or not player.valid return end
			if player == server or IsPlayerAdmin(player)
				COM_BufInsertText(player, "emp_toggleBuildingMode")
			else
				CONS_Printf(player, "\133ERROR: \128You tried to toggle building mode, but you need to either be the host or an admin to toggle building mode!\n")
			end
		end,
		blockSelectionMenu = function(player, key)
			if not player or not player.valid return end
			if isBuildingMode
				local pl_emp = player.empiralist
				pl_emp.currentMenuPage = 2
				pl_emp.currentMenuOption = 1
			else
				CONS_Printf(player, "\133ERROR: \128You tried to access the block selection menu, but the server needs to be in building mode for you to access this menu!\n")
			end
		end,
		mapDataMenu = function(player, key)
			if not player or not player.valid return end
			if player == server or IsPlayerAdmin(player)
				local pl_emp = player.empiralist
				pl_emp.currentMenuPage = 3
				pl_emp.currentMenuOption = 1
			else
				CONS_Printf(player, "\133ERROR: \128You tried to access the map data menu, but you need to either be the host or an admin to access this menu!\n")
			end
		end
	},
	mapDataMenu = {
		loadMapData = function(player, key)
			if not player or not player.valid return end
			if player != server and not IsPlayerAdmin(player) return end
			COM_BufInsertText(player, "emp_loadMapEmpiralistData")
		end,
		saveMapData = function(player, key)
			if not player or not player.valid return end
			if player != server and not IsPlayerAdmin(player) return end
			COM_BufInsertText(player, "emp_saveMapEmpiralistData")
		end,
		resetMapData = function(player, key)
			if not player or not player.valid return end
			if player != server and not IsPlayerAdmin(player) return end
			COM_BufInsertText(player, "emp_resetMapEmpiralistData")
		end
	}
}

local homeMenuPages = {
	{"Empiralist Home Menu", "empiralistHomeMenu", false, "empiralistHomeMenu", {{"Toggle building mode", "toggleBuildingMode", 16*FRACUNIT}, {"Block selection menu", "blockSelectionMenu", 20*FRACUNIT}, {"Map data menu", "mapDataMenu", 24*FRACUNIT}}, 0},
	{"Block Selection Menu", "blockSelectionMenu", true, "blockSelectionMenu"},
	{"Map Data Menu", "mapDataMenu", false, "mapDataMenu", {{"Load map data", "loadMapData", 16*FRACUNIT}, {"Save map data", "saveMapData", 20*FRACUNIT}, {"Reset map data", "resetMapData", 24*FRACUNIT}}, 1}
}

local homeMenuPageFuncs = {
	empiralistHomeMenu = function(drawer, player, screenWidth, screenHeight)
		if not player or not player.valid return end
		if gametype == GT_EMPIRALIST and gamemap == empiralistMapNum
			local pl_emp = player.empiralist
			for k,v in ipairs(homeMenuPages[1][5])
				if k == pl_emp.currentMenuOption
					drawer.drawString(FixedDiv(screenWidth, 2*FRACUNIT)-48*FRACUNIT, v[3], v[1], V_SNAPTOTOP|V_SNAPTOLEFT|V_YELLOWMAP|V_ALLOWLOWERCASE, "small-fixed")
				else
					drawer.drawString(FixedDiv(screenWidth, 2*FRACUNIT)-48*FRACUNIT, v[3], v[1], V_SNAPTOTOP|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "small-fixed")
				end
			end
		end
	end,
	blockSelectionMenu = function(drawer, player, screenWidth, screenHeight)
		if not player or not player.valid return end
		if gametype == GT_EMPIRALIST and gamemap == empiralistMapNum
			local currentX, currentY = 8*FRACUNIT, 24*FRACUNIT
			for k,v in ipairs(worldCellBlocks)
				local patchToDraw = drawer.cachePatch(v[1])
				drawer.drawScaled(currentX, currentY, FRACUNIT/8, patchToDraw, V_SNAPTOTOP|V_SNAPTOLEFT)
				local pl_emp = player.empiralist
				if k == pl_emp.currentMenuOption
					local patchToDraw2 = drawer.cachePatch("BLOCKCURSOR")
					local patchToDraw2Colormap = drawer.getColormap(player.mo.skin, player.mo.color)
					drawer.drawScaled(currentX, currentY, FRACUNIT/8, patchToDraw2, V_SNAPTOTOP|V_SNAPTOLEFT, patchToDraw2Colormap)
					if v[2] and type(v[2]) == "string"
						drawer.drawString(FixedDiv(screenWidth, 2*FRACUNIT)-44*FRACUNIT, 16*FRACUNIT, v[2], V_SNAPTOTOP|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin-fixed")
					else
						drawer.drawString(FixedDiv(screenWidth, 2*FRACUNIT)-44*FRACUNIT, 16*FRACUNIT, "???", V_SNAPTOTOP|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin-fixed")
					end
				end
				if currentX+(12*FRACUNIT) >= screenWidth
					currentX = 8*FRACUNIT
					currentY = $+(12*FRACUNIT)
				else
					currentX = $+(12*FRACUNIT)
				end
			end
		end
	end,
	mapDataMenu = function(drawer, player, screenWidth, screenHeight)
		if not player or not player.valid return end
		if gametype == GT_EMPIRALIST and gamemap == empiralistMapNum
			local pl_emp = player.empiralist
			for k,v in ipairs(homeMenuPages[3][5])
				if k == pl_emp.currentMenuOption
					drawer.drawString(FixedDiv(screenWidth, 2*FRACUNIT)-48*FRACUNIT, v[3], v[1], V_SNAPTOTOP|V_SNAPTOLEFT|V_YELLOWMAP|V_ALLOWLOWERCASE, "small-fixed")
				else
					drawer.drawString(FixedDiv(screenWidth, 2*FRACUNIT)-48*FRACUNIT, v[3], v[1], V_SNAPTOTOP|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "small-fixed")
				end
			end
		end
	end
}

local function changeSelectedHomeMenuPageOption(player, nextOption, selectedTable)
	if not player or not player.valid return end
	if not player.mo or not player.mo.valid return end
	if not nextOption or type(nextOption) != "number" return end
	if gametype == GT_EMPIRALIST and gamemap == empiralistMapNum
		local pl_emp = player.empiralist
		if pl_emp.currentMenuPage and type(pl_emp.currentMenuPage) == "number" and homeMenuPages[pl_emp.currentMenuPage] and type(homeMenuPages[pl_emp.currentMenuPage]) == "table"
			local actualMenuPage = homeMenuPages[pl_emp.currentMenuPage]
			if actualMenuPage[3]
				if not selectedTable or type(selectedTable) != "table" return end
				if nextOption == 1
					if pl_emp.currentMenuOption == 1
						pl_emp.currentMenuOption = #selectedTable
					else
						pl_emp.currentMenuOption = $-1
					end
				elseif nextOption == 2
					if pl_emp.currentMenuOption == #selectedTable
						pl_emp.currentMenuOption = 1
					else
						pl_emp.currentMenuOption = $+1
					end
				end
			else
				if nextOption == 1
					if pl_emp.currentMenuOption == 1
						pl_emp.currentMenuOption = #homeMenuPages[pl_emp.currentMenuPage][5]
					else
						pl_emp.currentMenuOption = $-1
					end
				elseif nextOption == 2
					if pl_emp.currentMenuOption == #homeMenuPages[pl_emp.currentMenuPage][5]
						pl_emp.currentMenuOption = 1
					else
						pl_emp.currentMenuOption = $+1
					end
				end
			end
		end
	end
end

COM_AddCommand("emp_setCurrentBlock", function(player, block)
	if not player or not player.valid return end
	if splitscreen return end
	if not block or type(block) != "string" return end
	local newBlock = tonumber(block)
	if not newBlock or type(newBlock) != "number" or newBlock <= 0 or newBlock > #worldCellBlocks return end
	if gametype == GT_EMPIRALIST and gamemap == empiralistMapNum
		local pl_emp = player.empiralist
		pl_emp.currentBlock = newBlock
	end
end)

local homeMenuAbstractPageThinkers = {
	blockSelectionMenu = function(player, key)
		if not player or not player.valid return end
		if not key.repeated
			local pl_emp = player.empiralist
			if key.name == "left arrow"
				changeSelectedHomeMenuPageOption(player, 1, worldCellBlocks)
			elseif key.name == "right arrow"
				changeSelectedHomeMenuPageOption(player, 2, worldCellBlocks)
			elseif key.name == "enter"
				COM_BufInsertText(player, "emp_setCurrentBlock " + tostring(pl_emp.currentMenuOption))
				toggleHomeMenu(player)
			elseif key.name == "backspace"
				pl_emp.currentMenuPage = 1
				pl_emp.currentMenuOption = 1
			end
		end
	end
}

local function homeMenuNonAbstractPageThinker(player, key)
	if not player or not player.valid return end
	if not key.repeated
		if key.name == "up arrow"
			changeSelectedHomeMenuPageOption(player, 1)
		elseif key.name == "down arrow"
			changeSelectedHomeMenuPageOption(player, 2)
		elseif key.name == "enter"
			local pl_emp = player.empiralist
			if pl_emp.currentMenuPage and type(pl_emp.currentMenuPage) == "number" and homeMenuPages[pl_emp.currentMenuPage] and type(homeMenuPages[pl_emp.currentMenuPage]) == "table"
				local actualMenuPage = homeMenuPages[pl_emp.currentMenuPage]
				if pl_emp.currentMenuOption and type(pl_emp.currentMenuOption) == "number" and not actualMenuPage[3] and actualMenuPage[5] and type(actualMenuPage[5]) == "table" and actualMenuPage[5][pl_emp.currentMenuOption] and type(actualMenuPage[5][pl_emp.currentMenuOption]) == "table"
					local actualMenuOption = actualMenuPage[5][pl_emp.currentMenuOption]
					if actualMenuPage[4] and type(actualMenuPage[4]) == "string" and homeMenuOptionFuncs[actualMenuPage[4]] and type(homeMenuOptionFuncs[actualMenuPage[4]]) == "table"
						local actualMenuOptionFuncTable = homeMenuOptionFuncs[actualMenuPage[4]]
						if actualMenuOption[2] and type(actualMenuOption[2]) == "string" and actualMenuOptionFuncTable[actualMenuOption[2]] and type(actualMenuOptionFuncTable[actualMenuOption[2]]) == "function"
							local actualMenuOptionFunc = actualMenuOptionFuncTable[actualMenuOption[2]]
							actualMenuOptionFunc(player, key)
						end
					end
				end
			end
		elseif key.name == "backspace"
			local pl_emp = player.empiralist
			if pl_emp.currentMenuPage and type(pl_emp.currentMenuPage) == "number" and homeMenuPages[pl_emp.currentMenuPage] and type(homeMenuPages[pl_emp.currentMenuPage]) == "table"
				local actualMenuPage = homeMenuPages[pl_emp.currentMenuPage]
				if actualMenuPage[6] and type(actualMenuPage[6]) == "number"
					pl_emp.currentMenuPage = actualMenuPage[6]
					pl_emp.currentMenuOption = 1
				else
					toggleHomeMenu(player)
					return true
				end
			end
		end
	end
end

addHook("NetVars", function(net)
	worldCellBlocks = net($)
	worldCells = net($)
	playerSpriteLayers = net($)
	isBuildingMode = net($)
	mapEmpiralistDataProgressMode = net($)
	mainFileName = net($)
	//extraFileName = net($)
end)

addHook("PlayerSpawn", setupPlayerEmpiralistData)

local function toggleAllowMovement(player)
	if not player or not player.valid return end
	local pl_emp = player.empiralist
	if pl_emp.allowMovement
		pl_emp.allowMovement = false
		CONS_Printf(player, "You are now unable to move! Please press the score key to enable movement!\n")
	else
		pl_emp.allowMovement = true
		CONS_Printf(player, "You are now able to move again! Please press the score key to disable movement!\n")
	end
end

addHook("KeyDown", function(key)
	if not consoleplayer or not consoleplayer.valid return end
	if splitscreen return end
	local pl_emp = consoleplayer.empiralist
	if gametype == GT_EMPIRALIST and gamemap == empiralistMapNum
		if pl_emp.worldCell >= 1
			if key.num == input.gameControlToKeyNum(GC_SCORES)
				if not key.repeated
					toggleAllowMovement(consoleplayer)
				end
				return true
			elseif key.name == "home"
				if not key.repeated
					toggleHomeMenu(consoleplayer)
				end
				return true
			end
			if not pl_emp.allowMovement or consoleplayer.playerstate != PST_LIVE return end
			if pl_emp.inHomeMenu
				if pl_emp.currentMenuPage and type(pl_emp.currentMenuPage) == "number" and homeMenuPages[pl_emp.currentMenuPage] and type(homeMenuPages[pl_emp.currentMenuPage]) == "table"
					local actualMenuPage = homeMenuPages[pl_emp.currentMenuPage]
					if actualMenuPage[3]
						if actualMenuPage[4] and type(actualMenuPage[4]) == "string" and homeMenuAbstractPageThinkers[actualMenuPage[4]] and type(homeMenuAbstractPageThinkers[actualMenuPage[4]]) == "function"
							local actualMenuPageThinker = homeMenuAbstractPageThinkers[actualMenuPage[4]]
							return actualMenuPageThinker(consoleplayer, key)
						end
					else
						return homeMenuNonAbstractPageThinker(consoleplayer, key)
					end
				end
			else
				if isBuildingMode
					if not key.repeated
						if key.name == "backspace"
							COM_BufInsertText(player, "emp_deleteBlockAtCurrentLocation")
							return
						elseif key.name == "enter"
							COM_BufInsertText(player, "emp_placeBlockAtCurrentLocation")
							return
						end
					end
				else
					if key.num == input.gameControlToKeyNum(GC_TURNLEFT)
						COM_BufInsertText(consoleplayer, "emp_turnDirection 1")
						return
					elseif key.num == input.gameControlToKeyNum(GC_TURNRIGHT)
						COM_BufInsertText(consoleplayer, "emp_turnDirection 2")
						return
					end
				end
				if key.num == input.gameControlToKeyNum(GC_FORWARD)
					COM_BufInsertText(consoleplayer, "emp_moveDirection 1")
				elseif key.num == input.gameControlToKeyNum(GC_STRAFELEFT)
					COM_BufInsertText(consoleplayer, "emp_moveDirection 2")
				elseif key.num == input.gameControlToKeyNum(GC_BACKWARD)
					COM_BufInsertText(consoleplayer, "emp_moveDirection 3")
				elseif key.num == input.gameControlToKeyNum(GC_STRAFERIGHT)
					COM_BufInsertText(consoleplayer, "emp_moveDirection 4")
				end
			end
		end
	end
end)

COM_AddCommand("emp_deleteBlockAtCurrentLocation", function(player)
	if not player or not player.valid return end
	if not player.mo or not player.mo.valid return end
	if gametype == GT_EMPIRALIST and gamemap == empiralistMapNum
		local pl_emp, mo_emp = player.empiralist, player.mo.empiralist
		if pl_emp.worldCell and type(pl_emp.worldCell) == "number" and worldCells[pl_emp.worldCell] and type(worldCells[pl_emp.worldCell]) == "table"
			if mo_emp.charSpriteX != nil and type(mo_emp.charSpriteX) == "number" and mo_emp.charSpriteY != nil and type(mo_emp.charSpriteY) == "number"
				local charSpriteXInt, charSpriteYInt = FixedInt(mo_emp.charSpriteX), FixedInt(mo_emp.charSpriteY)
				if worldCells[pl_emp.worldCell] and type(worldCells[pl_emp.worldCell]) == "table" and worldCells[pl_emp.worldCell][1] and type(worldCells[pl_emp.worldCell][1]) == "table"
					local currentWorldCellMap = worldCells[pl_emp.worldCell][1]
					if currentWorldCellMap[charSpriteYInt] and type(currentWorldCellMap[charSpriteYInt]) == "table"
						local currentWorldCellPosY = currentWorldCellMap[charSpriteYInt]
						if currentWorldCellPosY[charSpriteXInt] != nil
							currentWorldCellPosY[charSpriteXInt] = nil
						end
					end
				end
			end
		end
	end
end)

COM_AddCommand("emp_placeBlockAtCurrentLocation", function(player)
	if not player or not player.valid return end
	if not player.mo or not player.mo.valid return end
	if gametype == GT_EMPIRALIST and gamemap == empiralistMapNum
		local pl_emp, mo_emp = player.empiralist, player.mo.empiralist
		if not pl_emp.currentBlock or type(pl_emp.currentBlock) != "number" or pl_emp.currentBlock <= 0 or pl_emp.currentBlock > #worldCellBlocks return end 
		if pl_emp.worldCell and type(pl_emp.worldCell) == "number" and worldCells[pl_emp.worldCell] and type(worldCells[pl_emp.worldCell]) == "table"
			if mo_emp.charSpriteX != nil and type(mo_emp.charSpriteX) == "number" and mo_emp.charSpriteY != nil and type(mo_emp.charSpriteY) == "number"
				local charSpriteXInt, charSpriteYInt = FixedInt(mo_emp.charSpriteX), FixedInt(mo_emp.charSpriteY)
				if charSpriteXInt <= 0 or charSpriteXInt > 256 or charSpriteYInt <= 0 or charSpriteYInt > 256 return end
				if worldCells[pl_emp.worldCell] and type(worldCells[pl_emp.worldCell]) == "table" and worldCells[pl_emp.worldCell][1] and type(worldCells[pl_emp.worldCell][1]) == "table"
					local currentWorldCellMap = worldCells[pl_emp.worldCell][1]
					if currentWorldCellMap[charSpriteYInt] == nil or type(currentWorldCellMap[charSpriteYInt]) != "table"
						currentWorldCellMap[charSpriteYInt] = {}
					end
					local currentWorldCellPosY = currentWorldCellMap[charSpriteYInt]
					for k,v in ipairs(worldCellBlocks)
						if k == pl_emp.currentBlock
							if v[1] and type(v[1]) == "string"
								currentWorldCellPosY[charSpriteXInt] = v[1]
							end
							return
						end
					end
				end
			end
		end
	end
end)

COM_AddCommand("emp_turnDirection", function(player, direction)
	if not player or not player.valid return end
	if not player.mo or not player.mo.valid return end
	if splitscreen return end
	if not direction or type(direction) != "string" return end
	local newDirection = tonumber(direction)
	if not newDirection or type(newDirection) != "number" return end
	if gametype == GT_EMPIRALIST and gamemap == empiralistMapNum
		local mo_emp = player.mo.empiralist
		if newDirection == 1
			if mo_emp.charSpriteAngle <= 1 or mo_emp.charSpriteAngle > 8
				mo_emp.charSpriteAngle = 8
			else
				mo_emp.charSpriteAngle = $-1
			end
		elseif newDirection == 2
			if mo_emp.charSpriteAngle < 1 or mo_emp.charSpriteAngle >= 8
				mo_emp.charSpriteAngle = 1
			else
				mo_emp.charSpriteAngle = $+1
			end
		end
	end
end)

local function moveCharacterSprite(player, distanceX, distanceY)
	if not player or not player.valid return end
	if not player.mo or not player.mo.valid return end
	if gametype == GT_EMPIRALIST and gamemap == empiralistMapNum
		local pl_emp, mo_emp = player.empiralist, player.mo.empiralist
		local newCharSpriteX, newCharSpriteY = mo_emp.charSpriteX, mo_emp.charSpriteY
		if distanceX and type(distanceX) == "number"
			newCharSpriteX = $+(distanceX)
		end
		if distanceY and type(distanceY) == "number"
			newCharSpriteY = $+(distanceY)
		end
		if (not distanceX or type(distanceX) != "number") and (not distanceY or type(distanceY) != "number") return end
		local newCharSpriteFloorIntX, newCharSpriteFloorIntY = FixedInt(FixedFloor(newCharSpriteX)), FixedInt(FixedFloor(newCharSpriteY))
		if newCharSpriteFloorIntX <= 0 or newCharSpriteFloorIntX > 256 or newCharSpriteFloorIntY <= 0 or newCharSpriteFloorIntY > 256 return end
		if worldCells[pl_emp.worldCell] and worldCells[pl_emp.worldCell][1] and worldCells[pl_emp.worldCell][1][newCharSpriteFloorIntY] and worldCells[pl_emp.worldCell][1][newCharSpriteFloorIntY][newCharSpriteFloorIntX]
			local newWorldCellToMoveTo = worldCells[pl_emp.worldCell][1][newCharSpriteFloorIntY][newCharSpriteFloorIntX]
			for k,v in ipairs(worldCellBlocks)
				if v[1] == newWorldCellToMoveTo
					if v[3]
						mo_emp.charSpriteX, mo_emp.charSpriteY = newCharSpriteX, newCharSpriteY
					end
					return
				end
			end
		end
	end
end

COM_AddCommand("emp_moveDirection", function(player, direction)
	if not player or not player.valid return end
	if not player.mo or not player.mo.valid return end
	if splitscreen return end
	if not direction or type(direction) != "string" return end
	local newDirection = tonumber(direction)
	if not newDirection or type(newDirection) != "number" return end
	if gametype == GT_EMPIRALIST and gamemap == empiralistMapNum
		local mo_emp = player.mo.empiralist
		if isBuildingMode
			if newDirection == 1
				mo_emp.charSpriteY = $-FRACUNIT
			elseif newDirection == 2
				mo_emp.charSpriteX = $-FRACUNIT
			elseif newDirection == 3
				mo_emp.charSpriteY = $+FRACUNIT
			elseif newDirection == 4
				mo_emp.charSpriteX = $+FRACUNIT
			end
		else
			if newDirection == 1
				if mo_emp.charSpriteAngle == 1
					moveCharacterSprite(player, 0, FRACUNIT/4)
				elseif mo_emp.charSpriteAngle == 2
					moveCharacterSprite(player, -FRACUNIT/4, FRACUNIT/4)
				elseif mo_emp.charSpriteAngle == 3
					moveCharacterSprite(player, -FRACUNIT/4, 0)
				elseif mo_emp.charSpriteAngle == 4
					moveCharacterSprite(player, -FRACUNIT/4, -FRACUNIT/4)
				elseif mo_emp.charSpriteAngle == 5
					moveCharacterSprite(player, 0, -FRACUNIT/4)
				elseif mo_emp.charSpriteAngle == 6
					moveCharacterSprite(player, FRACUNIT/4, -FRACUNIT/4)
				elseif mo_emp.charSpriteAngle == 7
					moveCharacterSprite(player, FRACUNIT/4, 0)
				elseif mo_emp.charSpriteAngle == 8
					moveCharacterSprite(player, FRACUNIT/4, FRACUNIT/4)
				end
			elseif newDirection == 2
				if mo_emp.charSpriteAngle == 1
					moveCharacterSprite(player, FRACUNIT/4, 0)
				elseif mo_emp.charSpriteAngle == 2
					moveCharacterSprite(player, FRACUNIT/4, FRACUNIT/4)
				elseif mo_emp.charSpriteAngle == 3
					moveCharacterSprite(player, 0, FRACUNIT/4)
				elseif mo_emp.charSpriteAngle == 4
					moveCharacterSprite(player, -FRACUNIT/4, FRACUNIT/4)
				elseif mo_emp.charSpriteAngle == 5
					moveCharacterSprite(player, -FRACUNIT/4, 0)
				elseif mo_emp.charSpriteAngle == 6
					moveCharacterSprite(player, -FRACUNIT/4, -FRACUNIT/4)
				elseif mo_emp.charSpriteAngle == 7
					moveCharacterSprite(player, 0, -FRACUNIT/4)
				elseif mo_emp.charSpriteAngle == 8
					moveCharacterSprite(player, FRACUNIT/4, -FRACUNIT/4)
				end
			elseif newDirection == 3
				if mo_emp.charSpriteAngle == 1
					moveCharacterSprite(player, 0, -FRACUNIT/4)
				elseif mo_emp.charSpriteAngle == 2
					moveCharacterSprite(player, FRACUNIT/4, -FRACUNIT/4)
				elseif mo_emp.charSpriteAngle == 3
					moveCharacterSprite(player, FRACUNIT/4, 0)
				elseif mo_emp.charSpriteAngle == 4
					moveCharacterSprite(player, FRACUNIT/4, FRACUNIT/4)
				elseif mo_emp.charSpriteAngle == 5
					moveCharacterSprite(player, 0, FRACUNIT/4)
				elseif mo_emp.charSpriteAngle == 6
					moveCharacterSprite(player, -FRACUNIT/4, FRACUNIT/4)
				elseif mo_emp.charSpriteAngle == 7
					moveCharacterSprite(player, -FRACUNIT/4, 0)
				elseif mo_emp.charSpriteAngle == 8
					moveCharacterSprite(player, -FRACUNIT/4, -FRACUNIT/4)
				end
			elseif newDirection == 4
				if mo_emp.charSpriteAngle == 1
					moveCharacterSprite(player, -FRACUNIT/4, 0)
				elseif mo_emp.charSpriteAngle == 2
					moveCharacterSprite(player, -FRACUNIT/4, -FRACUNIT/4)
				elseif mo_emp.charSpriteAngle == 3
					moveCharacterSprite(player, 0, -FRACUNIT/4)
				elseif mo_emp.charSpriteAngle == 4
					moveCharacterSprite(player, FRACUNIT/4, -FRACUNIT/4)
				elseif mo_emp.charSpriteAngle == 5
					moveCharacterSprite(player, FRACUNIT/4, 0)
				elseif mo_emp.charSpriteAngle == 6
					moveCharacterSprite(player, FRACUNIT/4, FRACUNIT/4)
				elseif mo_emp.charSpriteAngle == 7
					moveCharacterSprite(player, 0, FRACUNIT/4)
				elseif mo_emp.charSpriteAngle == 8
					moveCharacterSprite(player, -FRACUNIT/4, FRACUNIT/4)
				end
			end
		end
	end
end)

addHook("SpinSpecial", function(player)
	if not player or not player.valid return end
	if not player.mo or not player.mo.valid return end
	if gametype == GT_EMPIRALIST and gamemap == empiralistMapNum
		return true
	end
end)

addHook("JumpSpecial", function(player)
	if not player or not player.valid return end
	if not player.mo or not player.mo.valid return end
	if gametype == GT_EMPIRALIST and gamemap == empiralistMapNum
		return true
	end
end)

local function addPlayerSpritesToTable(player)
	if not player or not player.valid return end
	if not player.mo or not player.mo.valid return end
	local mo_emp = player.mo.empiralist
	playerSpriteLayers[#player+1] = mo_emp.charSpriteY
end

local function sortPlayerSpritesByLayers()
	playerSpriteLayers = {}
	for i=1,#players
		playerSpriteLayers[i] = 0
	end
	for player in players.iterate
		addPlayerSpritesToTable(player)
	end
	table.sort(playerSpriteLayers)
	for i=1, #players
		if playerSpriteLayers[i-1] and playerSpriteLayers[i] and playerSpriteLayers[i-1] == playerSpriteLayers[i]
			playerSpriteLayers[i] = 0
		end
	end
	table.sort(playerSpriteLayers)
end

addHook("PostThinkFrame", function()
	if gametype == GT_EMPIRALIST and gamemap == empiralistMapNum and not splitscreen
		if isBuildingMode
			playerSpriteLayers = nil
		else
			sortPlayerSpritesByLayers()
		end
	else
		playerSpriteLayers = nil
		isBuildingMode = false
		mapEmpiralistDataProgressMode = 0
	end
end)

local function cacheBlock(drawer, player, worldCellDrawBlock)
	if not player or not player.valid return end
	for k,v in ipairs(worldCellBlocks)
		if v[1] == worldCellDrawBlock
			return drawer.cachePatch(worldCellDrawBlock)
		end
	end
end

local function drawActiveWorldCell(drawer, player, realWorldCellX, realWorldCellY, worldCellDrawX, worldCellDrawY, worldCellCanvasWidth, worldCellCanvasHeight, worldCellDrawPatch)
	if not player or not player.valid return end
	local pl_emp, mo_emp = player.empiralist, player.mo.empiralist
	local newWorldCellDrawX, newWorldCellDrawY, newRealWorldCellX, newRealWorldCellY, newWorldCellDrawPatch
	if worldCellDrawPatch and userdataType(worldCellDrawPatch) == "patch_t" and worldCellDrawPatch.width == 64 and worldCellDrawPatch.height == 64
		drawer.drawScaled(worldCellDrawX, worldCellDrawY, FRACUNIT/4, worldCellDrawPatch, V_SNAPTOTOP|V_SNAPTOLEFT)
	end
	if worldCellDrawX >= worldCellCanvasWidth
		newWorldCellDrawX = 0
		newWorldCellDrawY = worldCellDrawY+(16*FRACUNIT)
		newRealWorldCellX = FixedInt(FixedTrunc(mo_emp.charSpriteX)-FixedDiv(worldCellCanvasWidth, 32*FRACUNIT))+1
		newRealWorldCellY = realWorldCellY+1
	else
		newWorldCellDrawX = worldCellDrawX+(16*FRACUNIT)
		newWorldCellDrawY = worldCellDrawY
		newRealWorldCellX = realWorldCellX+1
		newRealWorldCellY = realWorldCellY
	end
	if newWorldCellDrawY >= worldCellCanvasHeight return end
	if worldCells[pl_emp.worldCell] and worldCells[pl_emp.worldCell][1] and worldCells[pl_emp.worldCell][1][newRealWorldCellY] and worldCells[pl_emp.worldCell][1][newRealWorldCellY][newRealWorldCellX]
		newWorldCellDrawPatch = cacheBlock(drawer, player, worldCells[pl_emp.worldCell][1][newRealWorldCellY][newRealWorldCellX])
	end
	return drawActiveWorldCell(drawer, player, newRealWorldCellX, newRealWorldCellY, newWorldCellDrawX, newWorldCellDrawY, worldCellCanvasWidth, worldCellCanvasHeight, newWorldCellDrawPatch)
end

local function drawCharacterSprites(drawer, player, screenWidth, screenHeight, drawLayer)
	if not player or not player.valid return end
	if not player.mo or not player.mo.valid return end
	local pl_emp, mo_emp = player.empiralist, player.mo.empiralist
	if not playerSpriteLayers or type(playerSpriteLayers) != "table" return end
	local charAngleRotationHack = ANGLE_MAX-ANG2
	if playerSpriteLayers[drawLayer] and playerSpriteLayers[drawLayer] == mo_emp.charSpriteY
		local charDrawX, charDrawY = FixedDiv(screenWidth, 2*FRACUNIT)-(16*FRACUNIT), FixedDiv(screenHeight, 2*FRACUNIT)-(2*FRACUNIT)
		local charDrawOffsetX, charDrawOffsetY = 0, 0
		if FixedTrunc(mo_emp.charSpriteX) == mo_emp.charSpriteX-(FRACUNIT/4)
			charDrawOffsetX = 4*FRACUNIT
		elseif FixedTrunc(mo_emp.charSpriteX) == mo_emp.charSpriteX-(FRACUNIT/2)
			charDrawOffsetX = 8*FRACUNIT
		elseif FixedTrunc(mo_emp.charSpriteX) == mo_emp.charSpriteX-FixedDiv(FixedMul(3*FRACUNIT, FRACUNIT), 4*FRACUNIT)
			charDrawOffsetX = 12*FRACUNIT
		end
		if FixedTrunc(mo_emp.charSpriteY) == mo_emp.charSpriteY-(FRACUNIT/4)
			charDrawOffsetY = 4*FRACUNIT
		elseif FixedTrunc(mo_emp.charSpriteY) == mo_emp.charSpriteY-(FRACUNIT/2)
			charDrawOffsetY = 8*FRACUNIT
		elseif FixedTrunc(mo_emp.charSpriteY) == mo_emp.charSpriteY-FixedDiv(FixedMul(3*FRACUNIT, FRACUNIT), 4*FRACUNIT)
			charDrawOffsetY = 12*FRACUNIT
		end
		charDrawX, charDrawY = $+charDrawOffsetX+(2*FRACUNIT), $+charDrawOffsetY+FRACUNIT
		local charToDraw = drawer.getSprite2Patch(player.mo.skin, SPR_PLAY, false, player.mo.frame, mo_emp.charSpriteAngle, charAngleRotationHack)
		local charColormap
		if player.playerstate == PST_LIVE
			charColormap = drawer.getColormap(player.mo.skin, player.mo.color)
		else
			charColormap = drawer.getColormap(TC_DASHMODE, player.mo.color)
		end
		if charToDraw
			drawer.drawScaled(charDrawX, charDrawY, FRACUNIT/5, charToDraw, V_SNAPTOTOP|V_SNAPTOLEFT, charColormap)
		end
	end
	for anotherPlayer in players.iterate
		local apl_emp, amo_emp = anotherPlayer.empiralist, anotherPlayer.mo.empiralist
		if anotherPlayer and anotherPlayer.valid and anotherPlayer.mo and anotherPlayer.mo.valid and anotherPlayer != player and apl_emp.cellWorld == pl_emp.cellWorld and playerSpriteLayers[drawLayer] and playerSpriteLayers[drawLayer] == amo_emp.charSpriteY
			local anotherCharDrawX, anotherCharDrawY, anotherCharDrawOffsetX, anotherCharDrawOffsetY
			if FixedTrunc(amo_emp.charSpriteX) == amo_emp.charSpriteX-(FRACUNIT/4)
				anotherCharDrawOffsetX = 4*FRACUNIT
			elseif FixedTrunc(amo_emp.charSpriteX) == amo_emp.charSpriteX-(FRACUNIT/2)
				anotherCharDrawOffsetX = 8*FRACUNIT
			elseif FixedTrunc(amo_emp.charSpriteX) == amo_emp.charSpriteX-FixedDiv(FixedMul(3*FRACUNIT, FRACUNIT), 4*FRACUNIT)
				anotherCharDrawOffsetX = 12*FRACUNIT
			else
				anotherCharDrawOffsetX = 0
			end
			if FixedTrunc(amo_emp.charSpriteY) == amo_emp.charSpriteY-(FRACUNIT/4)
				anotherCharDrawOffsetY = 4*FRACUNIT
			elseif FixedTrunc(amo_emp.charSpriteY) == amo_emp.charSpriteY-(FRACUNIT/2)
				anotherCharDrawOffsetY = 8*FRACUNIT
			elseif FixedTrunc(amo_emp.charSpriteY) == amo_emp.charSpriteY-FixedDiv(FixedMul(3*FRACUNIT, FRACUNIT), 4*FRACUNIT)
				anotherCharDrawOffsetY = 12*FRACUNIT
			else
				anotherCharDrawOffsetY = 0
			end
			anotherCharDrawX, anotherCharDrawY = FixedDiv(screenWidth, 2*FRACUNIT)-(16*FRACUNIT)+FixedMul((FixedTrunc(amo_emp.charSpriteX)-FixedTrunc(mo_emp.charSpriteX)), 16*FRACUNIT)+anotherCharDrawOffsetX+(2*FRACUNIT), FixedDiv(screenHeight, 2*FRACUNIT)-(2*FRACUNIT)+FixedMul((FixedTrunc(amo_emp.charSpriteY)-FixedTrunc(mo_emp.charSpriteY)), 16*FRACUNIT)+anotherCharDrawOffsetY+FRACUNIT
			local anotherCharToDraw = drawer.getSprite2Patch(anotherPlayer.mo.skin, SPR_PLAY, false, anotherPlayer.mo.frame, amo_emp.charSpriteAngle, charAngleRotationHack)
			local anotherCharColormap
			if anotherPlayer.quittime
				anotherCharColormap = drawer.getColormap(TC_RAINBOW, anotherPlayer.mo.color)
			elseif anotherPlayer.playerstate == PST_LIVE
				anotherCharColormap = drawer.getColormap(anotherPlayer.mo.skin, anotherPlayer.mo.color)
			else
				anotherCharColormap = drawer.getColormap(TC_DASHMODE, anotherPlayer.mo.color)
			end
			if anotherCharToDraw
				drawer.drawScaled(anotherCharDrawX, anotherCharDrawY, FRACUNIT/5, anotherCharToDraw, V_SNAPTOTOP|V_SNAPTOLEFT, anotherCharColormap)
			end
		end
	end
	if drawLayer >= 1 and drawLayer < 32
		return drawCharacterSprites(drawer, player, screenWidth, screenHeight, drawLayer+1)
	end
end

local function drawBuilderPatches(drawer, player, screenWidth, screenHeight)
	if not player or not player.valid return end
	if not player.mo or not player.mo.valid return end
	local pl_emp, mo_emp = player.empiralist, player.mo.empiralist
	if pl_emp.currentBlock and type(pl_emp.currentBlock) == "number" and pl_emp.currentBlock >= 1 and pl_emp.currentBlock <= #worldCellBlocks
		local builderPosX, builderPosY = FixedDiv(screenWidth, 2*FRACUNIT)-(16*FRACUNIT), FixedDiv(screenHeight, 2*FRACUNIT)-(4*FRACUNIT)
		local builderPatch1 = drawer.cachePatch(worldCellBlocks[pl_emp.currentBlock][1])
		local builderPatch2 = drawer.cachePatch("BLOCKCURSOR")
		local builderColormap
		if player.playerstate == PST_LIVE
			builderColormap = drawer.getColormap(player.mo.skin, player.mo.color)
		else
			builderColormap = drawer.getColormap(TC_DASHMODE, player.mo.color)
		end
		if builderPatch1
			drawer.drawScaled(builderPosX, builderPosY, FRACUNIT/4, builderPatch1, V_SNAPTOTOP|V_SNAPTOLEFT)
		end
		if builderPatch2
			drawer.drawScaled(builderPosX, builderPosY, FRACUNIT/4, builderPatch2, V_SNAPTOTOP|V_SNAPTOLEFT, builderColormap)
		end
	end
	for anotherPlayer in players.iterate
		local apl_emp, amo_emp = anotherPlayer.empiralist, anotherPlayer.mo.empiralist
		if anotherPlayer and anotherPlayer.valid and anotherPlayer.mo and anotherPlayer.mo.valid and anotherPlayer != player and apl_emp.cellWorld == pl_emp.cellWorld and apl_emp.currentBlock and type(apl_emp.currentBlock) == "number" and apl_emp.currentBlock >= 1 and apl_emp.currentBlock <= #worldCellBlocks
			local anotherBuilderPosX, anotherBuilderPosY = FixedDiv(screenWidth, 2*FRACUNIT)-(16*FRACUNIT)+FixedMul(amo_emp.charSpriteX-mo_emp.charSpriteX, 16*FRACUNIT), FixedDiv(screenHeight, 2*FRACUNIT)-(4*FRACUNIT)+FixedMul(amo_emp.charSpriteY-mo_emp.charSpriteY, 16*FRACUNIT)
			local anotherBuilderPatch1 = drawer.cachePatch(worldCellBlocks[apl_emp.currentBlock][1])
			local anotherBuilderPatch2 = drawer.cachePatch("BLOCKCURSOR")
			local anotherBuilderColormap
			if anotherPlayer.quittime
				anotherBuilderColormap = drawer.getColormap(TC_RAINBOW, anotherPlayer.mo.color)
			elseif anotherPlayer.playerstate == PST_LIVE
				anotherBuilderColormap = drawer.getColormap(anotherPlayer.mo.skin, anotherPlayer.mo.color)
			else
				anotherBuilderColormap = drawer.getColormap(TC_DASHMODE, anotherPlayer.mo.color)
			end
			if anotherBuilderPatch1
				drawer.drawScaled(anotherBuilderPosX, anotherBuilderPosY, FRACUNIT/4, anotherBuilderPatch1, V_SNAPTOTOP|V_SNAPTOLEFT)
			end
			if anotherBuilderPatch2
				drawer.drawScaled(anotherBuilderPosX, anotherBuilderPosY, FRACUNIT/4, anotherBuilderPatch2, V_SNAPTOTOP|V_SNAPTOLEFT, anotherBuilderColormap)
			end
		end
	end
end

hud.add(function(drawer, player)
	if not player or not player.valid return end
	if not player.mo or not player.mo.valid return end
	local screenWidth, screenHeight = (drawer.width()/drawer.dupx())*FRACUNIT, (drawer.height()/drawer.dupy())*FRACUNIT
	local screenWidthInt, screenHeightInt = FixedInt(screenWidth), FixedInt(screenHeight)
	if gametype == GT_EMPIRALIST and splitscreen
		if splitscreen // Splitscreen support will be added later on during alpha!
			drawer.drawFill(0, 0, screenWidthInt, screenHeightInt, 254)
			drawer.drawString(FixedDiv(screenWidth, 2*FRACUNIT)-96*FRACUNIT, 8*FRACUNIT, "Empiralist does not support splitscreen yet!", V_SNAPTOTOP|V_SNAPTOLEFT|V_REDMAP, "thin-fixed")
			return
		end
	end
	local pl_emp, mo_emp = player.empiralist, player.mo.empiralist
	if gametype == GT_EMPIRALIST and gamemap == empiralistMapNum and pl_emp.worldCell >= 1
		if pl_emp.inHomeMenu
			drawer.drawFill(0, 0, screenWidthInt, screenHeightInt, 122)
			if pl_emp.currentMenuPage and type(pl_emp.currentMenuPage) == "number" and homeMenuPages[pl_emp.currentMenuPage] and type(homeMenuPages[pl_emp.currentMenuPage]) == "table"
				local actualMenuPage = homeMenuPages[pl_emp.currentMenuPage]
				if actualMenuPage[1] and type(actualMenuPage[1]) == "string"
					drawer.drawString(FixedDiv(screenWidth, 2*FRACUNIT)-48*FRACUNIT, 8*FRACUNIT, actualMenuPage[1], V_SNAPTOTOP|V_SNAPTOLEFT|V_INVERTMAP, "thin-fixed")
				else
					drawer.drawString(FixedDiv(screenWidth, 2*FRACUNIT)-48*FRACUNIT, 8*FRACUNIT, "???", V_SNAPTOTOP|V_SNAPTOLEFT|V_INVERTMAP, "thin-fixed")
				end
				if actualMenuPage[2] and type(actualMenuPage[2]) == "string" and homeMenuPageFuncs[actualMenuPage[2]] and type(homeMenuPageFuncs[actualMenuPage[2]]) == "function"
					local actualMenuPageFunc = homeMenuPageFuncs[actualMenuPage[2]]
					actualMenuPageFunc(drawer, player, screenWidth, screenHeight)
				end
			end
		else
			local actualWorldCellX, actualWorldCellY = FixedInt(FixedTrunc(mo_emp.charSpriteX)-FixedDiv(screenWidth, 32*FRACUNIT))+1, FixedInt(FixedTrunc(mo_emp.charSpriteY)-FixedDiv(screenHeight, 48*FRACUNIT))-1
			local currentWorldCellDrawPatch
			if worldCells[pl_emp.worldCell] and worldCells[pl_emp.worldCell][1] and worldCells[pl_emp.worldCell][1][actualWorldCellY] and worldCells[pl_emp.worldCell][1][actualWorldCellY][actualWorldCellX]
				currentWorldCellDrawPatch = drawer.cachePatch(worldCells[pl_emp.worldCell][1][actualWorldCellY][actualWorldCellX])
			end
			drawer.drawFill(0, 0, screenWidth, screenHeight, 252)
			drawActiveWorldCell(drawer, player, actualWorldCellX, actualWorldCellY, 0, 0, screenWidth, screenHeight, currentWorldCellDrawPatch)
			if isBuildingMode
				drawBuilderPatches(drawer, player, screenWidth, screenHeight)
			else
				drawCharacterSprites(drawer, player, screenWidth, screenHeight, 1)
			end
		end
	end
end, "game")

addHook("SeenPlayer", function(player, seenplayer)
	if not player or not player.valid or not seenplayer or not seenplayer.valid return end
	if gametype == GT_EMPIRALIST return false end
end)

rawset(_G, "empiralist", {})

function empiralist.addCustomBlock(graphics, displayName, passable)
	if not graphics or type(graphics) != "string" return end
	if not displayName or type(displayName) != "string" return end
	if passable == nil or type(passable) != "boolean" return end
	local nextWorldCellBlockID = #worldCellBlocks+1
	worldCellBlocks[nextWorldCellBlockID] = {graphics, displayName, passable}
end
